<?php
//List records
//Tasks - change, delete, new
//To do:
//Bind import/export
$token=trim(escapeshellarg($_REQUEST["txtToken"])," '");
$acctnum=trim(escapeshellarg($_REQUEST["txtAcct"])," '");
$domainid=trim(escapeshellarg($_REQUEST["txtDomain"])," '");
?>
<html>
<head><title>DNS API Record List</title><head>
<body>
<?
//get record list
$resp=shell_exec('curl -s -k -H "X-Auth-Token: '.$token.'" https://dns.api.rackspacecloud.com/v1.0/'.$acctnum.'/domains/'.$domainid.' 2>&1');
$arrResp=json_decode(trim($resp),true);
$arrRecordsList=$arrResp["recordsList"];
$arrRecords=$arrRecordsList["records"];

echo '<h2>Domain '.$domainid.':</h2>';

echo "<table border=\"1\">";
echo "<tr><td>Name</td><td>".$arrResp["name"]."</td></tr>";
echo "<tr><td>EMail</td><td><input name=\"txtEMail\" value=\"".$arrResp["emailAddress"]."\" id='txtEMail' /></td></tr>";
echo "<tr><td>TTL</td><td><input name=\"txtTTL\" value=\"".$arrResp["ttl"]."\" id='txtTTL' /></td></tr>";
echo "<tr><td>Comment</td><td><input name=\"txtComment\" value=\"".$arrResp["comment"]."\" id='txtComment' /></td></tr>";
echo "<tr><td>Created</td><td>".$arrResp["created"]."</td></tr>";
echo "<tr><td>Updated</td><td>".$arrResp["updated"]."</td></tr>";
echo "</table>";
echo '<button value="Update" name="btnUpdate" onClick="moddomain();" >Update</button>';

echo '<h3>Nameservers:</h3>';
echo "<table border=\"1\">";
foreach ($arrResp["nameservers"] as $arrNS) {
	echo "<tr><td>".$arrNS["name"]."</td></tr>";
	}
echo "</table>";

echo '<h3>Records:</h3>';
echo "<table border=\"1\">";
echo "<tr><td>Name</td><td>Type</td><td>Content</td><td>TTL</td><td>Priority</td><td>Delete</td></tr>";
foreach ($arrRecords as $arrRecord) {
	echo "<tr><td>"
		."<a href='record.php?txtAcct=".$acctnum."&txtToken=".$token."&txtDomain=".$domainid."&txtRecID=".$arrRecord["id"]."'>".$arrRecord["name"]."</a>"
		."</td><td>".$arrRecord["type"]."</td><td>".$arrRecord["data"]."</td><td>".$arrRecord["ttl"]."</td><td>".$arrRecord["priority"]."</td><td>"
		."<a href='delrecord.php?txtAcct=".$acctnum."&txtToken=".$token."&txtDomain=".$domainid."&txtRecID=".$arrRecord["id"]."&btnSubmit=Remove'>[x]</a>"
		."</td></tr>";
	}

echo "</table>";
?>

<form method="get" action="addrecord.php" name="frmAddRecord">
<!--
name, includes domain
type A,AAAA,CNAME,NS,TXT,SRV,MX
-->
<h2>Add Record:</h2>
Account: <input name="txtAcct" value="<?=$acctnum ?>"/><br />
Token: <input name="txtToken" value="<?=$token ?>"/><br />
Domain ID: <input name="txtDomain" value="<?=$domainid ?>"/><br />
Name: <input name="txtName" /><br />
Type: <input name="txtType" /><br />
Data: <input name="txtData" /><br />
Priority: <input name="txtPriority" /><br />
TTL: <input name="txtTTL" /><br />
Comment: <input name="txtComment" /><br />
<button name="btnClear" type="reset">Clear</button>
<button value="Add" name="btnSubmit">Add</button>
</form>

<?php
//debugging output
echo "<hr/>Raw response:<br/>";
echo "<div style=\"border: 1px solid #000; height: 9em; overflow: auto; margin: 0.5em;\">";
echo nl2br($resp);
echo "</div>";
echo "<pre style=\"border: 1px solid #000; height: 9em; overflow: auto; margin: 0.5em;\">";
var_export($arrResp);
echo "</pre>\n<br/>";
?>
<script>
function moddomain() {
window.location = "moddomain.php?txtToken=<?=$token ?>&txtAcct=<?=$acctnum ?>&txtDomain=<?=$domainid ?>&txtTTL="+document.getElementById('txtTTL').value+"&txtEMail="+document.getElementById('txtEMail').value+"&txtComment="+document.getElementById('txtComment').value;
}
</script>
</body>
</html>
